
int getPaletteEntry(int x, int y){
	int row,col;
	row=(y-main_win->view->yPalette)/main_win->view->heightPalRow;
	col=x/main_win->view->widthPalCol;
	row*=main_win->view->cPaletteColumns;
	row+=col;
	if(row>=main_win->view->columns) row=-1;
	return row;
}


const char *getUnit(void){
	char* einheit;
	int a,b;
	myView *v;
	v=main_win->view;
	/* Haben alle aktiven Spalten die gleiche Einheit? */
    einheit=0;
    b=0;
	for(a=0;a<v->columns;a++){
		if(v->column[a].active){
			if(!einheit) einheit=v->column[a].unit;
			else if(strcmp(einheit,v->column[a].unit)) b=1;	/* verschiedene */
		}
	}
	if(b) return("");
	return einheit;
}	

void cb_test(Fl_Widget *w, void* vp)
{
	fl_alert("Callback Handler %ld",(long int) vp);
}

void cb_exclusive(Fl_Widget *w, void* vp)
{
	long int c;
	for(c=0;c<main_win->view->columns;c++){
		if(c==(long int) vp) main_win->view->column[c].active=1;
		else main_win->view->column[c].active=0;
	}
	main_win->redraw();
}

void cb_set_all_chan(Fl_Widget *w, void* vp)
{
	long int mode=(long int) vp;
	int c;
	for(c=0;c<main_win->view->columns;c++){
		switch(mode){
			case 0:
			main_win->view->column[c].active=0;
			break;
			case 1:
			main_win->view->column[c].active=1;
			break;
			case 2:
			main_win->view->column[c].active=main_win->view->column[c].act_def;
			break;
		}
	}
	main_win->redraw();
}

void cb_entire_file(Fl_Widget *w, void* vp)
{
	main_win->view->Zoom=main_win->view->Endzeit-main_win->view->Startzeit;
	main_win->view->Aktzeit=main_win->view->Startzeit;
	main_win->redraw();
}

void cb_PalettePropertys(Fl_Widget *w, void* vp)
{
	long int c;
	int red,green,blue;
	c=(long int) vp;
	char title[100],st1[100];
	if(c<0) return;
	ui->name->value(main_win->view->column[c].name);
	ui->unit->value(main_win->view->column[c].unit);
	red=(main_win->view->column[c].color>>24)&255;
	green=(main_win->view->column[c].color>>16)&255;
	blue=(main_win->view->column[c].color>>8)&255;
	sprintf(st1,"%02X",red);
	ui->red->value(st1);
	sprintf(st1,"%02X",green);
	ui->green->value(st1);
	sprintf(st1,"%02X",blue);
	ui->blue->value(st1);

	strcpy(title,gettext("Propertys channel"));
	sprintf(title+strlen(title)," %ld",c);
	ui->chan_prop->label(title);
	ui->chan_prop->show();
	ui->chan_prop->position(main_win->x()+20,main_win->y()+20);
	while (ui->chan_prop->visible()) Fl::wait();

	strcpy(main_win->view->column[c].name,ui->name->value());
	strcpy(main_win->view->column[c].unit,ui->unit->value());
	sscanf(ui->red->value(),"%x",&red);
	sscanf(ui->green->value(),"%x",&green);
	sscanf(ui->blue->value(),"%x",&blue);

	main_win->view->column[c].color=(red<<24)+(green<<16)+(blue<<8)+255;
	main_win->redraw();
}

void cb_click(void){
	int dx,dy,n,c;
	double t,y;
	dx=Fl::event_x();
	dy=Fl::event_y();
	n=Fl::event_clicks();
	if(dy>main_win->view->yPalette){
		c=getPaletteEntry(dx, dy);
		if(c>=0){
			if(n){	/* Palette Doppelklick: Kanal toggeln */
				if(main_win->view->column[c].active) main_win->view->column[c].active=0;
				else main_win->view->column[c].active=1;
				main_win->redraw();
			}
			else{	/* Palette Klick: aktuellen Kanal setzen */
				if(main_win->view->selectedChan==c)main_win->view->selectedChan=-1;
				else main_win->view->selectedChan=c;
			}
		main_win->redraw();
		}
	}
	else{
		dy=main_win->view->yDiagr-dy;
		y=dy;
		y=y/main_win->view->hDiagr*5;
		y=exp(y);	/* Vergrößerungsfaktor */
		//fl_alert("Vergrößerung: %lf",y);
		dx-=main_win->view->xDiagr;
		t=dx;
		t/=main_win->view->wDiagr;
		t*=main_win->view->Zoom;
		t+=main_win->view->Aktzeit;	/* Uhrzeit Klickpunkt */
		//fl_alert("Klickzeit ist %s",ut2hrt(t));
		main_win->view->Zoom/=y;		/* neue Vergrößerung */
		t-=main_win->view->Zoom/2;		/* soll jetzt Bildmitte werden */
		main_win->view->Aktzeit=t;
		main_win->redraw();
	}
}


/* Behandlung von Ereignissgen für die Diagrammfläche */
int myCanvas::handle(int e)
{
	char st1[200];
	int shift,ctrl,dx,dy,key;
	long int c;
	if(!e) return 1;
	if(!main_win->view->file) return 1;
	switch(e)
	{
	case FL_PUSH:
		switch(Fl::event_button())
		{
			case FL_LEFT_MOUSE:
			cb_click();
			return 1;

			case FL_MIDDLE_MOUSE:
			return 1;

			case FL_RIGHT_MOUSE:
			dx=Fl::event_x();
			dy=Fl::event_y();
			c=getPaletteEntry(dx,dy);
			if(dy<main_win->view->yPalette){
			Fl_Menu_Item rclick_menu[] = {	/* Kontextmenu Diagramm */
				{ "Diagramm 1",  0, cb_test, (void*)1 },
				{ "Do Thing 2",  0, cb_test, (void*)2 },
				{ "Do Thing 3",  0, cb_test, (void*)3 },
				{ gettext("Entire File"),  0, cb_entire_file},
				{ 0 }};

				const Fl_Menu_Item *m = rclick_menu->popup(Fl::event_x(), Fl::event_y(), 0, 0, 0);
				if (m) m->do_callback(main_win, m->user_data());
			}
			else{
			Fl_Menu_Item rclick_menu[] = {	/* Kontextmenu Paletten */
				{ gettext("All channels off"),  0, cb_set_all_chan, (void*)0 },
				{ gettext("All channels on"),  0, cb_set_all_chan, (void*)1 },
				{ gettext("All channels default"),  0, cb_set_all_chan, (void*)2 },
				{ gettext("This channel exclusive"), 0, cb_exclusive, (void*)c },
				{ gettext("Channel propertys"),  0, cb_PalettePropertys, (void*)c },
				{ 0 }};

				const Fl_Menu_Item *m = rclick_menu->popup(Fl::event_x(), Fl::event_y(), 0, 0, 0);
				if (m) m->do_callback(main_win, m->user_data());
			}
			return 1;
		}
		return 1;
	case FL_KEYDOWN:
		if(main_win->view->drawing) main_win->view->cancel=1;
		key=Fl::event_key();
		switch(key)
		{
			case 0xffab:
			case '+':
			main_win->view->Zoom/=2;
			if(!main_win->view->cancel) redraw();
			return 1;

			case 0xffad:
			case '-':
			main_win->view->Zoom*=2;
			if(!main_win->view->cancel) redraw();
			return 1;

			case FL_Up:
			main_win->view->offset+=main_win->view->Scale/10;
			redraw();
			return 1;

			case FL_Down:
			main_win->view->offset-=main_win->view->Scale/10;
			redraw();
			return 1;

			case FL_Page_Up:
			main_win->view->Scale/=2;
			redraw();
			return 1;

			case FL_Page_Down:
			main_win->view->Scale*=2;
			redraw();
			return 1;

			case FL_Left:
			main_win->view->Aktzeit-=main_win->view->Zoom/4;
			if(!main_win->view->cancel) redraw();
			return 1;

			case FL_Right:
			main_win->view->Aktzeit+=main_win->view->Zoom/4;
			if(!main_win->view->cancel) redraw();
			return 1;

			default:
			//fl_alert("key=0x%x",key);
			break;
		}
		return 1;

	case FL_MOUSEWHEEL:
		shift=Fl::event_shift();
		ctrl=Fl::event_ctrl();
		dy=Fl::event_dy();
		if(ctrl){
			if(dy>0) main_win->view->Zoom/=2;
			else main_win->view->Zoom*=2;
		}
		else{
			main_win->view->Aktzeit+=dy*main_win->view->Zoom/4;
		}
		main_win->redraw();
		break;

	case FL_MOVE:
		if(Fl::event_y()<main_win->view->yPalette){
			double x,y;
			x=((Fl::event_x()-main_win->view->xDiagr)*main_win->view->Zoom/main_win->view->wDiagr)+main_win->view->Aktzeit;
			y=((main_win->view->yDiagr-Fl::event_y())*main_win->view->Scale/main_win->view->hDiagr)+main_win->view->offset;
			sprintf(st1,"%s: %s %s: %4.2lf%s",gettext("Mouse Postition"),ut2hrt(x),gettext("Value"),y,getUnit());
		}
		else{
			strcpy(st1,"");
			key=getPaletteEntry(Fl::event_x(),Fl::event_y());
			if(key>=0) sprintf(st1,"%s (%s)",main_win->view->column[key].name,main_win->view->column[key].unit);
		}
		statusOut(st1);
		break;

	default:
		//sprintf(st1,"EVENT: %s(%d)\n", fl_eventnames[e], e);
		statusOut("");
		break;
	}
	return 1;
}

/**********************************************************************/

void myCanvas::draw(){
  struct tm t,*pTime;
  double tneu,modul,delta,lasttime,Morgen;
  double t1,raster;
  time_t tt;
  char st1[MAX_LINELENGTH],lastline[MAX_LINELENGTH],blk,*cp,*cp1;
  const char *einheit;
  int a,b,xakt,xalt,xneu,xscale,yalt,yneu,alttag,altmonat,
  monat,jahr,mod2,PrintFirstDate=1,
  OffsetPerChannel,ActOffset=0;
  int activeChannels=1;
  double d,f,v0,v1,v2,ipart,fpart,ystep;
  char horz[40],horz_alt[40],vert[40],date[40],time[40];
  int Xbase,Ybase;
  double Width;
  int *oldvalue,lastDateMark=0;
  struct{
	int left,top,right,bottom;
	}rcClient;

	myView* v;
	int ic,id,wx,wy,wh,ww,wh2;
	v=(myView*) user_data();
	if(!v) return;
	if(!v->file){
		return;
	}
	wx=x();
	wy=y();
	wh=h();
	ww=w();
	wh2=v->yPalette/2-40;
	fl_color(FL_WHITE);
	fl_rectf(0,wy,ww,wh);
	fl_color(FL_BLACK);
	fl_font(1,v->sizeFont);

  /* Geometrie einstellen */
  Xbase=v->xDiagr;
  Ybase=v->yDiagr;
  rcClient.left=v->xDiagr;
  rcClient.right=v->xDiagr+v->wDiagr;
  rcClient.top=v->yDiagr-v->hDiagr;
  rcClient.bottom=v->yDiagr;

  /* Gültigkeitsprüfung/Korrektur aller Variablen */
  if((rcClient.bottom-rcClient.top<200)
   ||(rcClient.right-rcClient.left<100)
   ||(!v->file)) return;

  if(v->Zoom<0.0000001) v->Zoom=0.0000001;
  f=v->Endzeit-v->Startzeit;
  if(v->Zoom>f) v->Zoom=f;
  if(v->Aktzeit<v->Startzeit) v->Aktzeit=v->Startzeit;
  f=v->Endzeit-v->Zoom;
  if(v->Aktzeit>f) v->Aktzeit=f;

  if(v->Scale>=100000000) v->Scale=100000000;
  if(v->Scale<0.00125) v->Scale=0.00125;
  sprintf(v->Filterstring,"%%d.%%d.%%d%c%%d:%%d:%%lf",v->ActSeparatorChar);

   /* Falls Ausdruck: Dateinamen ausgeben */
   if(v->print)
    {
    }
    einheit=getUnit();
    /* Die Y-Skala ausgeben *******************************************/
    Width=10;
	Width=(double)fl_height()/2;
    if(v->Stacked)
     {
     float opc;
     activeChannels=0;
     for(a=0;a<v->columns;a++)
      {
      if(v->column[a].active) activeChannels++;
      }
     if(!activeChannels) activeChannels++;
     opc=(Ybase-rcClient.top)/(activeChannels+0.5);
     OffsetPerChannel=opc;
     ActOffset=OffsetPerChannel/2;
     for(a=0;a<v->columns;a++)
      {
      if(v->column[a].active)
       {
        strcpy(st1,v->column[a].name);
        fl_draw(st1,rcClient.left,(Ybase-Width*0.6)-ActOffset);
        fl_line(Xbase,Ybase-ActOffset,rcClient.right,Ybase-ActOffset);
		ActOffset+=OffsetPerChannel;
       }
      }
     }
    else
     {
     /* wie weite Skalenstriche wollen wir machen? */
     a=Ybase-rcClient.top; /* Nutzbare Pixel in der Höhe */
     ystep=1000000000000;
     while (a*ystep>Width*v->Scale*15) ystep/=10;
     if (a*ystep>Width*v->Scale*8) ystep/=5;
     if (a*ystep>Width*v->Scale*3) ystep/=2;
     v1=fmod(v->offset,ystep);
     if(v1) v0=ystep-v1;
     else v0=0;
     do
     {
       yneu=Ybase-v0*a/v->Scale;
       v1=v0;
       if(v->Pairmode) v1*=2;
       v1+=v->offset;
       fl_color(FL_BLACK);
       if(v->Scale>60) sprintf(st1,"%7.0lf %s",v1,einheit);
       else if (v->Scale>10) sprintf(st1,"%6.1lf %s",v1,einheit);
       else if (v->Scale>1) sprintf(st1,"%6.2lf %s",v1,einheit);
       else sprintf(st1,"%6.4lf %s",v1,einheit);
		fl_color(FL_BLACK);
       fl_draw(st1,v->xValueScale,yneu+0.3*fl_height());
		fl_color(0xc0c0c0ff);	/* hellgrau */
       fl_line(Xbase,yneu,rcClient.right,yneu);
       v0+=ystep;
      }
     while(yneu>=rcClient.top+10);  /* nah am oberen Rand */
     }

    /* Die X-Skala ausgeben *******************************************/
	Width=(double)fl_height()/v->wDiagr/2;
    raster=0.00000001;
    if(v->Zoom*Width/10>0.0000000005) raster=0.00000002;
    if(v->Zoom*Width/10>0.000000001) raster=0.00000005;
    if(v->Zoom*Width/10>0.000000002) raster=0.0000001;
    if(v->Zoom*Width/10>0.000000005) raster=0.0000002;
    if(v->Zoom*Width/10>0.00000001) raster=0.0000005;
    if(v->Zoom*Width/10>0.00000002) raster=0.000001;
    if(v->Zoom*Width/10>0.00000005) raster=0.000002;
    if(v->Zoom*Width/10>0.0000001) raster=0.000005;
    if(v->Zoom*Width/10>0.0000002) raster=0.00001;
    if(v->Zoom*Width/10>0.0000005) raster=0.00002;
    if(v->Zoom*Width/10>0.000001) raster=0.00005;
    if(v->Zoom*Width/10>0.000002) raster=0.0001;
    if(v->Zoom*Width/10>0.000005) raster=0.0002;
    if(v->Zoom*Width/10>0.00001) raster=0.0005;
    if(v->Zoom*Width/10>0.00002) raster=0.001;
    if(v->Zoom*Width/10>0.00005) raster=0.002;
    if(v->Zoom*Width/10>0.0001) raster=0.005;
    if(v->Zoom*Width/10>0.0002) raster=0.01;
    if(v->Zoom*Width/10>0.0005) raster=0.02;
    if(v->Zoom*Width/10>0.001) raster=0.05;
    if(v->Zoom*Width/10>0.002) raster=0.1;
    if(v->Zoom*Width/10>0.005) raster=0.2;
    if(v->Zoom*Width/10>0.01) raster=0.5;
    if(v->Zoom*Width/10>0.02) raster=1;
    if(v->Zoom*Width/10>0.05) raster=2;
    if(v->Zoom*Width/10>0.1) raster=5;
    if(v->Zoom*Width/10>0.2) raster=10;
    if(v->Zoom*Width/10>0.5) raster=30;
    if(v->Zoom*Width/10>1) raster=60;
    if(v->Zoom*Width/10>2) raster=120;
    if(v->Zoom*Width/10>5) raster=300; /* 5 Minuten */
    if(v->Zoom*Width/10>10) raster=600; /* 10 Minuten */
    if(v->Zoom*Width/10>20) raster=1200; /* 20 Minuten */
    if(v->Zoom*Width/10>30) raster=1800; /* 30 Minuten */
    if(v->Zoom*Width/10>60) raster=3600; /* 1 Stunde */
    if(v->Zoom*Width/10>120) raster=7200; /* jede 2. Stunde */
    if(v->Zoom*Width/10>360) raster=21600; /* 6 Stunden */
    if(v->Zoom*Width/10>720) raster=43200; /* 12 Stunden */
    if(v->Zoom*Width/10>1440) raster=86400; /* ein Tag */
    if(v->Zoom*Width/10>6000) raster=604800; /* eine Woche */

    /* Zeitachse zeichnen */
    horz_alt[0]=0;
    alttag=32;			/* gibt es nicht, also neu ausgeben */
    altmonat=13;
    /* Offset Startzeit zum ersten "glatten" Rasterpunkt */
    delta=raster-raster*modf(v->Aktzeit/raster,&ipart);
    do
      {
       time_t tt;
       ipart=delta*v->wDiagr/v->Zoom+Xbase;
       xakt=ipart;
       tt=delta+v->Aktzeit+0.0001;
       fpart=modf(delta+v->Aktzeit,&ipart);
       pTime=localtime(&tt);
       if(raster<1)
       {
       fpart+=pTime->tm_sec;
       sprintf(horz,"%02d:%02d",pTime->tm_hour,pTime->tm_min);
       sprintf(vert,"%09.6lf",fpart);
       }
       else
       {
        if(raster<43200)
        {
        sprintf(vert,"%02d:%02d:%02d",pTime->tm_hour,pTime->tm_min,pTime->tm_sec);
        sprintf(horz,"%02d.%02d.%04d",pTime->tm_mday,pTime->tm_mon+1,pTime->tm_year+1900);
        }
        else
        {
        sprintf(vert,"%02d.%02d.",pTime->tm_mday,pTime->tm_mon+1);
        sprintf(horz,"%04d",pTime->tm_year+1900);
        }
       }
	 /* vertikale Beschriftung zeichnen */
		fl_color(FL_BLACK);
      	 fl_draw(90,vert,xakt+fl_height()*0.3,v->yTimeScale);
		fl_color(0xc0c0c0ff);	/* hellgrau */
      	 fl_line(xakt,Ybase,xakt,rcClient.top);
		/* horizontale Beschriftung zeichen? */
         if(strcmp(horz,horz_alt))
         {
		fl_color(FL_BLACK);
		if(xakt>lastDateMark) fl_draw(horz,xakt,v->yDateScale);
    	 lastDateMark=xakt+fl_width(horz);
       	 if(((pTime->tm_mday > alttag)||(pTime->tm_mon > altmonat))&&(raster<14400))
       	  {
      	   fl_line(xakt,Ybase,xakt,rcClient.top);
      	  }
      	  alttag=pTime->tm_mday;
      	  strcpy(horz_alt,horz);
	 }
	alttag=pTime->tm_mday;
	altmonat=pTime->tm_mon;
      	delta=delta+raster;
       } while (xakt<(rcClient.right-30));

	/******************************************************************/
      /* Die Kurven Zeichnen */
      //statusOut("Diagramm wird gezeichnet, bitte warten!");
      RewindFile(v);
      st1[0]=0;
      lastline[0]=0;
      t1=0;
      oldvalue=(int*) calloc(sizeof(int),main_win->view->columns);

	/* bis zur Startposition vorspulen */
	do
	{
		lasttime=t1;			/* Die wird */
		strcpy(lastline,st1);		/* vielleicht noch gebraucht */
		ReadLine(st1,v);
		/* Zeitstempel lesen */
		t1=ReadTime(st1,&cp,v);
	}
	while ((t1<v->Aktzeit)&&(!feof(v->file)));
	if(!strlen(lastline))
	{
		strcpy(lastline,st1); /*war die erste Zeile*/
		lasttime=t1;
	}

	/* vorherigen Datensatz aus der LastLine erfassen */
	lasttime=ReadTime(lastline,&cp,v);
	xalt=Xbase+((lasttime-v->Aktzeit)*v->wDiagr/v->Zoom);
	for(a=0;a<v->columns;a++)
	{
		v0=parse(&cp,0,v);
		blk=v->InvalidValue;
		if(v->Pairmode)
		{
			double v2;
			v2=parse(&cp,0,v);
			v0=(v0+v2)/2;
			v0-=v->offset/2;
		}
		else v0-=v->offset;
		v0+=v->column[a].offset;
		v0=v0*(Ybase-rcClient.top)/v->Scale;
		yneu=Ybase-v0;
		oldvalue[a]=yneu;
		v->column[a].blk=blk;
		if(v->Pairmode) a++;
	}

	/* folgende Datensätze erfassen */
	for(a=0;a<v->columns;a++) v->column[a].akt=0;
	v->cancel=0;
	v->drawing=1;

	/* Clipregion zuordnen */
	fl_push_clip(v->xDiagr,v->yDiagr-v->hDiagr,v->wDiagr,v->hDiagr+1);

	do
	{
	/* Zeitstempel lesen */
	cp=st1;
	tneu=ReadTime(st1,&cp,v);
    xalt=Xbase+((lasttime-v->Aktzeit)*v->wDiagr/v->Zoom);
    xneu=Xbase+((tneu-v->Aktzeit)*v->wDiagr/v->Zoom);
    ActOffset=0;
    if(v->Stacked) ActOffset=OffsetPerChannel/2;
	for(a=0;a<v->columns;a++)
	    {
	     v0=parse(&cp,v->column[a].akt,v);
	     v->column[a].akt=v0;
	     if(v->column[a].active)
	      {
	       blk=v->InvalidValue;
	       if(v->Pairmode)
			{
			v2=parse(&cp,v->column[a+1].akt,v);
			v->column[a+1].akt=v2;
			v0=(v0+v2)/2;
			v0-=v->offset/2;
			}
	       else v0-=v->offset;
	       v0=v0*(Ybase-rcClient.top);
	       v0=v0/v->Scale;
			yneu=Ybase-v0;
			yalt=oldvalue[a];
			if(((xakt!=xneu)||(yalt!=yneu))&&(!blk)&&(!v->column[a].blk))
				{
				fl_color(v->column[a].color);
				if(a==main_win->view->selectedChan)fl_line_style(0,3);
				else fl_line_style(0,0);
				fl_line(xalt,yalt,xneu,yneu);
				}
			oldvalue[a]=yneu;
			v->column[a].blk=blk;
			if(v->Stacked) ActOffset+=OffsetPerChannel;
	      }
	     else
	      {
	       if(v->Pairmode)
			{
			parse(&cp,0,v);
			}
	      }
	      if(v->Pairmode) a++;
	     }
	lasttime=tneu;
	ReadLine(st1,v);	/* nächste Zeile */
	//Fl::wait(0); /* Testen ob inzwischen eine Taste gedrückt wurde */
	}
	while ((xneu<rcClient.right)&&(!feof(v->file))&&(!v->cancel));
	fl_line_style(0,0);

	fl_pop_clip();
	free(oldvalue);
	v->drawing=0;
	for(id=0;id<v->cPaletteLines;id++){
		for(ic=0;ic<v->cPaletteColumns;ic++){
			if(ic+id*v->cPaletteColumns<v->columns){
				if(v->column[ic+id*v->cPaletteColumns].active) fl_color(v->column[ic+id*v->cPaletteColumns].color);
				else fl_color(FL_GRAY);
				fl_rectf(ic*v->widthPalCol,v->yPalette+id*v->heightPalRow,v->widthPalCol-2,v->heightPalRow-2);
				fl_color(FL_BLACK);
				strcpy(st1,v->column[ic+id*v->cPaletteColumns].name);
				if(ic+id*v->cPaletteColumns==v->selectedChan) strcat(st1," *");
				fl_draw(st1,ic*v->widthPalCol+4,v->yPalette+(id+1)*v->heightPalRow-6);
			}
		}
	}
 main_win->bt_left->redraw();
 main_win->bt_right->redraw();
 main_win->bt_up->redraw();
 main_win->bt_down->redraw();
}

void myCanvas::resize(int x, int y, int w, int h)
	{
		char st1[200];
		int c;
		myView* v;
		Fl_Box::resize(x,y,w,h);
		v=(myView*) user_data();
		if(!v) return;
		if(!v->file) return;
		/* wie viel Platz für die Palette brauchen wir? */
		fl_font(1,v->sizeFont);
		v->widthPalCol=(int)(fl_width(v->longestColName)+12);
		v->cPaletteColumns=w/v->widthPalCol&0xfffe;
		if(v->cPaletteColumns>v->columns) v->cPaletteColumns=v->columns;
		v->widthPalCol=w/v->cPaletteColumns;
		v->heightPalRow=fl_height()+6;
		c=v->columns;
		v->cPaletteLines=0;
		while(c>0){
			v->cPaletteLines++;
			c-=v->cPaletteColumns;
		}
		v->yPalette=y+h-v->heightPalRow*v->cPaletteLines;
		v->xDiagr=x+20+fl_width("Testzeile");
		v->yDateScale=v->yPalette-20;
		v->yTimeScale=v->yDateScale-fl_height();
		v->yDiagr=v->yDateScale-fl_width("Testspalte00");
		v->wDiagr=w-10-v->xDiagr;
		v->hDiagr=v->yDiagr-40;
		v->xValueScale=20;
	}
