char languageFile[PATH_MAX];

char* getConfName(void){
	static char configName[PATH_MAX],*cp;
#ifdef WIN32
	cp=getenv("APPDATA");
	if(!cp){
		fl_alert("Homedir not readable!\n");
		exit(-1);
	}
	strcpy(configName,cp);
	strcat(configName,"/csvplot.conf");
#else
	cp=getenv("HOME");
	if(!cp){
		fl_alert("Homedir not readable!\n");
		exit(-1);
	}
	strcpy(configName,cp);
	strcat(configName,"/.config/csvplot.conf");
#endif
	return configName;
}

int writeConfig(const char* filename,myView *v){
	FILE *f;
	mru_rec *mru_act,*mru_next;
	int m;
	f=fopen(filename,"w");
	if(!f) return -1;
	fprintf(f,"language_file=%s\n",languageFile);
	fprintf(f,"window=%d,%d,%d,%d\n",main_win->x(),main_win->y(),main_win->w(),main_win->h());
	fprintf(f,"fontsize=%d\n",v->sizeFont);
	fprintf(f,"default_unit=%s\n",v->DefUnit);
	fprintf(f,"ps_file_name=%s\n",v->PsFileName);
	fprintf(f,"ps_resolution=%d\n",v->PsResolution);
	fprintf(f,"time_format=%d\n",v->Zeitformat);
	fprintf(f,"separator_char=%d\n",v->separator);
	fprintf(f,"head_lines=%d\n",v->HeadLines);
	fprintf(f,"time_interval=%lf\n",v->Interval);
	fprintf(f,"format_file=%s\n",v->formatFile);
	fprintf(f,"recent_file=%s,%lf,%lf,%lf,%lf\n",v->WorkFileName,v->Scale,v->Zoom,v->Aktzeit,v->offset);
	m=1;
	mru_act=v->mru;
	v->mru=0;
	while(mru_act){
		if((strcmp(v->WorkFileName,mru_act->name))
		&&(m<20)){
			if(strlen(mru_act->name)) fprintf(f,"recent_file%d=%s,%lf,%lf,%lf,%lf\n",m,mru_act->name,mru_act->Scale,mru_act->Zoom,mru_act->Aktzeit,mru_act->offset);
		}
		mru_next=mru_act->next;
		free(mru_act);
		mru_act=mru_next;
		m++;
	}
	fclose(f);
	return 0;
}

int readConfig(char* param,myView *v){
	char *cp;
	double d=1;
	cp=strchr(param,'=');
	if(!cp) return -1;
	*cp=0;
	cp++;

	if(!strcmp(param,"language_file")){
		strcpy(languageFile,cp);
		return 0;
	}

	if(!v) return 0;

	if(!strcmp(param,"time_interval")){
		sscanf(cp,"%lf",&d);
		v->Interval=d;
		return 0;
	}

	if(!strcmp(param,"format_file")){
		strcpy(v->formatFile,cp);
		return 0;
	}

	if(!strcmp(param,"window")){
		int x,y,w,h;
		sscanf(cp,"%d,%d,%d,%d",&x,&y,&w,&h);
		main_win->size(w,h);
		main_win->position(x,y);
		main_win->size_range(640,480);
		return 0;
	}

	if(!strcmp(param,"fontsize")){
		v->sizeFont=atoi(cp);
		return 0;
	}

	if(!strcmp(param,"separator_char")){
		v->separator=atoi(cp);
		return 0;
	}

	if(!strcmp(param,"time_format")){
		v->Zeitformat=atoi(cp);
		return 0;
	}

	if(!strcmp(param,"head_lines")){
		v->HeadLines=atoi(cp);
		return 0;
	}

	if(!strcmp(param,"ps_resolution")){
		v->PsResolution=atoi(cp);
		return 0;
	}

	if(!strcmp(param,"default_unit")){
		strcpy(v->DefUnit,cp);
		return 0;
	}

	if(!strcmp(param,"ps_file_name")){
		strcpy(v->PsFileName,cp);
		return 0;
	}

	if(!strncmp(param,"recent_file",11)){
		mru_rec *mn,*act;
		int c;
		char* arg[20];
		c=parseLine(arg,cp,',',18);
		if(c<5) return -1;
		mn=(mru_rec*)calloc(1,sizeof(mru_rec));
		strcpy(mn->name,arg[0]);
		sscanf(arg[1],"%lf",&mn->Scale);
		sscanf(arg[2],"%lf",&mn->Zoom);
		sscanf(arg[3],"%lf",&mn->Aktzeit);
		sscanf(arg[4],"%lf",&mn->offset);
		if(!v->mru){
			v->mru=mn;
			return 0;
		}
		act=v->mru;
		while(act->next) act=act->next;
		act->next=mn;
		return 0;
	}

	printf("unknown parameter: %s\n",param);
	return -1;
}

int readConfigFile(const char* filename,myView *v){
	FILE *f;
	char st1[10000],*cp;;
	mru_rec *mru_act,*mru_next;
	if(v){
	/* erstmal alte MRUs löschen */
	mru_act=v->mru;
	v->mru=0;
	while(mru_act){
		mru_next=mru_act->next;
		free(mru_act);
		mru_act=mru_next;
	}
	}
	f=fopen(filename,"r");
	if(!f) return -1;
	while(fgets(st1,9990,f)){
		if(cp=strchr(st1,'\n')) *cp=0;
		readConfig(st1,v);
	}
	fclose(f);
	return 0;
}

int evalCmdArgs(void){
	myView *v;
	char st1[2048];
	int c;
	v=main_win->view;
	for(c=1;c<g_argc;c++){
		if(g_argv[c][0]=='-'){
			strcpy(st1,g_argv[c]+1);
			readConfig(st1,main_win->view);
		}
		else{
			strcpy(v->WorkFileName,g_argv[c]);
		}
	}
	return 0;
}
