/* Zeitstempel lesen */
double ReadTime(char *st,char **rp,myView *v)
{
 int monat,jahr;
 struct tm t;
 time_t tt;
 double zeit,sec=0;
 char *cp;
 /* Kommas in der Zeile durch Punkte ersetzen */
 cp=st;
 if(v->separator!=',') while (cp=strchr(cp,',')) *cp='.';
 if(cp=strchr(st,'\n')) *cp=0;  /*Zeilenendezeichen umwandeln*/

 switch(v->Zeitformat)
 {

 case 1: /* Unixzeit Sekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }

 case 2: /* Unixzeit Millisekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000;
  }

 case 3: /* Unixzeit Mikrosekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000000;
  }

 case 4: /* Unixzeit Nanosekunden */
  {
  cp=strchr(st,v->separator);
  //if(cp) *cp=0;
  sscanf(st,"%lf",&zeit);
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  if(cp) *rp=cp+1; else *rp=0;
  return zeit/1000000000;
  }

 case 5: /* YYYY-MM-DD hh:mm:ss */
  {
  memset(&t,0,sizeof(t));
  sscanf(st,"%d-%d-%d %d:%d:%lf",&jahr,&monat,&t.tm_mday,
		  &t.tm_hour,&t.tm_min,&sec);
  t.tm_sec=0; /* werden später addiert */
  t.tm_mon=monat-1;
  t.tm_year=jahr-1900;
  t.tm_isdst=-1;
  tt=mktime(&t);
  zeit=tt;	/* ganzzahliger Teil */
  zeit=zeit+sec;
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  cp=strchr(st,v->separator);
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }

  case 6: /* TT.MM.JJJJ hh:mm */
  {
  memset(&t,0,sizeof(t));
  sscanf(st,"%d.%d.%d %d:%d:%lf",&t.tm_mday,&monat,&jahr,
		  &t.tm_hour,&t.tm_min,&sec);
  t.tm_sec=0; /* werden später addiert */
  t.tm_mon=monat-1;
  t.tm_year=jahr-1900;
  t.tm_isdst=-1;
  tt=mktime(&t);
  zeit=tt;	/* ganzzahliger Teil */
  zeit=zeit+sec;
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  cp=strchr(st,v->separator);
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }

 case 7: /* keine Zeitstempel, festes Intervall */
 {
	zeit=0;
	zeit=v->Aktzeit;
	v->Aktzeit+=v->Interval;
	return zeit;
 }

case 8: /* YYYY.MM.DD;hh:mm:ss[.ms] */
	{
	memset(&t,0,sizeof(t));
	sscanf(st,"%d.%d.%d;%d:%d:%lf",&jahr,&monat,&t.tm_mday,
		  &t.tm_hour,&t.tm_min,&sec);
	t.tm_sec=0; /* werden später addiert */
	t.tm_mon=monat-1;
	t.tm_year=jahr-1900;
	t.tm_isdst=-1;
	tt=mktime(&t);
	zeit=tt;	/* ganzzahliger Teil */
	zeit=zeit+sec;
	/* *rp soll Zeiger auf ersten Wert zurückliefern */
	cp=strchr(st,';');
	if(cp) cp=strchr(cp+1,v->separator);
	if(cp) *rp=cp+1; else *rp=0;
	return zeit;
	}

 default:
  {
  memset(&t,0,sizeof(t));
  sscanf(st,v->Filterstring,&t.tm_mday,&monat,&jahr,
		  &t.tm_hour,&t.tm_min,&sec);
  t.tm_sec=0; /* werden später addiert */
  t.tm_mon=monat-1;
  t.tm_year=jahr-1900;
  t.tm_isdst=-1;
  tt=mktime(&t);
  zeit=tt;	/* ganzzahliger Teil */
  zeit=zeit+sec;
  /* *rp soll Zeiger auf ersten Wert zurückliefern */
  cp=strchr(st,v->separator);
  if(cp) cp=strchr(cp+1,v->separator);
  if(cp) *rp=cp+1; else *rp=0;
  return zeit;
  }
 }
}
